#ifndef _Constants_H
#define _Constants_H
const int MAX_UNIT_CELL=7;
const int MAX_NUM_SYM=100;

// size of the descriptor index, smaller is faster, 1D=3, 2D=7, 3Dm2=19 3Dm4=23
const int MAX_SPIN_LIST=60;   // MAX_BT*uc<=block_size*MAX_SPIN_LIST

const int MAX_NUM_CONFIGURATIONS=1000; // max=mem/(2*MAX_SPIN_LIST*int) 
const int MAX_NUM_NEIGHBOURS=10;
const int MAX_LSUBM=40;      // max distance and max flips (ToDo: add LSUBN)
const int MAX_BT=20000;      // sites of bounding triangle, (m+dim)!/(m!dim!)
const int MAX_NUM_ITERATIONS=10000;
const double TOLERANCE=1e-10;  // old= 1e-12

// MAX_NUMBER_TERMS_IN_CCM_EQNS should be a prime number for good hashing
// const int MAX_NUMBER_TERMS_IN_CCM_EQNS=262251; // 2^18-1 for s=1/2-LC-12
const int MAX_NUMBER_TERMS_IN_CCM_EQNS=524287; // 2^19-1 for s=1/2-LC-14

/* momentum of convergence for direct iteration
 * next vector is a mixture of momentum*oldX + (1-momentum)*newX
 * high momentum is more stable but slower
 * low  momentum is faster but probably dont converge */
const double momentum=0.625; /* old=0.7 */

#ifndef PARALLEL_FLAG
#define PARALLEL_FLAG 0
#endif
#endif
