/* this file is included in ccm.C only, its not a usual .h file */
#ifndef _GlobalVariables_h
#define _GlobalVariables_h 1

#include "../include/Externals.h"   // define structures (Joerg Sep05)

prm Params;        // CCM parameter
ctrl Control;      // program Control Parameters
UC UnitCell;       // defines the unit cell completely
sub sublatticeMagnetisation;  // defines the subLattice
neighbours LatticeNeighbours;
bravais BravaisLattice;
symmetries LatticeSymmetries;
spinConfigs spinConfigurations[MAX_NUM_CONFIGURATIONS];
// spinConfigs connectedConfigurations[MAX_NUM_CONFIGURATIONS];
spinConfigs latticeAnimals[MAX_NUM_CONFIGURATIONS];
int         NumberConfigurations;
int         NumberLatticeAnimals;

double CCMcoeffs[MAX_NUM_CONFIGURATIONS]={0.0};

hamiltonian_defn Hamiltonian_types[MAX_BONDS+1][MAX_TERMS_t];
hamiltonian_defn Hamiltonian      [MAX_BONDS+1][MAX_TERMS_h];

// Other global variables.

int  max_number_cells_BT;
int lookUpTable[MAX_BT+1][5];
int BTarray[MAX_LSUBM+1][MAX_LSUBM+1][MAX_LSUBM+1];

// removed (not used, Joerg05)
// double x_array[2];
// double y_array[2];
// double z_array[2];
// int    x_index[2];
// int    y_index[2];
// int    z_index[2];
// int    cell_index[2];
int    totalPoints;

/* obtain */

int binary_max[31];
int trimary_max[MAX_LSUBM+1];
int quartary_max[MAX_LSUBM+1];

// file pointers.

char terms_fname[80]; /* term file fileName */
int  terms_shm_fd=-1; /* term file descriptor, if SHM used */
FILE *terms_fp=NULL;  /* term file */
FILE *fp_gs;          /* gs-terms */
FILE *fp1;            /* input.ccm */
FILE *fp2;            /* output.results */
/*
 * - linux has no problems by using all free memory as IO cache
 *   and give it back on demand, so we dont need lot of extra buffer
 * - solaris has a buffer cache of fixed size, this is bad and
 *   can cause excessiv disk access where there is enough free memory 
 *   or dont give back memory when other jobs need it
 * - so the user can choose full buffering to reduce disk access to 0
 *  
 */
char *fp_buf=NULL;    /* read/write buffer may be bigger than the file */

// solve variables.

double maximum;
double minimum;
double increment;

// restriction on choice of clusters.

int restrictionClusters;

// direction bonds or not?

int directional;

// restriction of sweeping for F_k F_m s_k^z s_m^z terms.

int midPointX;
int midPointY;
int midPointZ;
int radius;

// solution strategy

int solutionStrategy;

// parallel variables

int myid;
int npe;
#endif
